define output parameter o-sumId as integer no-undo.
def var i as int no-undo. 
def buffer root-sum for book.
def buffer tmp-sum for book.

define variable tmpId as integer no-undo.


LOCK-BLK:
repeat transaction on error undo, retry:

    if retry then
    do:
        assign tmpId = ?.
        leave LOCK-BLK.
    end.

    find root-sum exclusive-lock 
        where root-sum.book-id = 777
        no-wait no-error.

    if available root-sum then
    do:
        if sold-qty > 500000 then
            assign root-sum.sold-qty = 1.
        else
            assign root-sum.sold-qty = root-sum.sold-qty + 1.
            
        assign tmpId = int(root-sum.sold-qty).
    end.

    else 
    do:
        if locked root-sum then 
        do:
            pause 1 no-message.
            next LOCK-BLK.
        end.

        else
        do:
            create root-sum.
            assign root-sum.book-id = 777
                   root-sum.isbn = "Lock Record For incrementing id"
                   root-sum.sold-qty = 1
                   tmpId           = int(root-sum.sold-qty).
        end.
    end.

    find tmp-sum no-lock
       where tmp-sum.book-id  = tmpId
         no-error.
                               
    if available tmp-sum then
       next LOCK-BLK.
       
    create tmp-sum.
    assign tmp-sum.book-id = tmpId
           tmp-sum.isbn = "".
    
    leave LOCK-BLK.

end.

assign o-sumId = tmpId.

