/* procedure p3:  displays all records */

DEFINE SHARED BUFFER x-book FOR book.
DEFINE SHARED VARIABLE cnt AS INTEGER NO-UNDO.
DEFINE SHARED STREAM log.

FUNCTION d RETURNS LOGICAL(INPUT s AS CHARACTER, INPUT p1 AS CHARACTER, INPUT p2 AS CHARACTER):
   cnt = cnt + 1.
   DISPLAY
      cnt FORMAT ">9"
      s   FORMAT "x(20)"
      p1
      p2
      SKIP WITH FRAME f0 WITH NO-BOX NO-LABELS.

   DISPLAY STREAM log
      cnt FORMAT ">9"
      s   FORMAT "x(20)"
      p1
      p2
      SKIP WITH FRAME f0 WITH NO-BOX NO-LABELS.
END FUNCTION.

d("P3 start", "", "").

d("  before incomplete loop", x-book.isbn, "").
FOR EACH x-book:
    d(STRING(book-id, ">>>>>>9"), isbn, "").
    /* display x-book.book-id x-book.isbn with 15 down. */
   LEAVE. /* leave after displaying 1st item */
END.
d("  after incomplete loop", if available(x-book) then x-book.isbn else "n/a", "").

d("  before complete loop", x-book.isbn, "").
FOR EACH x-book:
    d(STRING(book-id, ">>>>>>9"), isbn, "").
    /* display x-book.book-id x-book.isbn with 15 down. */
END.
d("  after complete loop", if available(x-book) then x-book.isbn else "n/a", "").

d("P3 end", "", ""). /* end of 3rd procedure. */
