DEFINE VARIABLE cnt AS INTEGER INIT 0 NO-UNDO.

FUNCTION d RETURNS LOGICAL(INPUT s AS CHARACTER, INPUT p1 AS CHARACTER, INPUT p2 AS CHARACTER):
   cnt = cnt + 1.
   DISPLAY
      cnt FORMAT ">9"
      s FORMAT "x(20)"
      p1
      p2
      SKIP WITH FRAME f0 WITH NO-BOX NO-LABELS.
END FUNCTION.

ON WRITE OF book OLD BUFFER obook
    d("   Writing book", book.isbn, obook.isbn).

ON ASSIGN OF book.isbn OLD VALUE oi
    d("   Assigning ", book.isbn, oi).

d("1st processing started", "validation", "off").
FOR EACH book:
   d("iteratig", book.isbn, ?).

   IF (book-id EQ 69896) THEN DO:
      d("altering", book.isbn, ?).
      book.isbn = "0011".
   END.
END.
MESSAGE isbn.  /* 1st warning should before-buffer printed */

d("2nd processing started", "validation", "on").
FOR EACH book:
   d("iteratig", book.isbn, ?).

   IF (book-id EQ 69896) THEN DO:
      d("altering", book.isbn, ?).
      book.isbn = "0012".
      VALIDATE book.
   END.
END.
MESSAGE isbn.  /* 2nd warning should before-buffer printed */

d("3rd processing started", "leave", ?).
FOR EACH book:
   d("iteratig", book.isbn, ?).

   IF (book-id EQ 69896) THEN DO:
      d("altering", book.isbn, ?).
      book.isbn = "0013".
      LEAVE.
   END.
END.

MESSAGE isbn.  /* NO warning should before-buffer printed */

d("All ok", ?, ?).
