/* write of book is not detected! */

/* utility function */
DEFINE VARIABLE cnt AS INTEGER INIT 0 NO-UNDO.
FUNCTION d RETURNS LOGICAL(INPUT s AS CHARACTER, INPUT p1 AS CHARACTER, INPUT p2 AS CHARACTER):
   cnt = cnt + 1.
   DISPLAY
   cnt FORMAT ">9"
   s FORMAT "x(20)"
   p1
   p2
   SKIP WITH FRAME f0 WITH NO-BOX NO-LABELS.
END FUNCTION.

/* configure then trigger for write event */
ON WRITE OF book OLD BUFFER obook
    d("Writing book", book.isbn, obook.isbn).



/* cleanup from and previous run */
FIND FIRST book WHERE book-id EQ 0 NO-ERROR.
IF AVAILABLE(book) THEN DO:
   d("Found old book [", book.isbn, "]").
   DELETE book.
    /*quit.*/
END.

/*creating test record */
CREATE book.

/* force validation that should fire then write event */
DO TRANSACTION:
    book.isbn = "2".
    VALIDATE book.   /* will fire WRITE event/trigger (?)*/

    PAUSE MESSAGE "wait for undo".
    UNDO, LEAVE.     /* UNDO what? */
END.

d("After undo [", book.isbn, "]").

/*
 1 Found old book [              ]
 2 Writing book         2
 3 After undo [                  ]

 * however, the new record is written to database using CREATE event
 * then then WRITE trigger will update it to 2
 * then silently the UNDO will reset it back to empty.
 */
