/*
 * This part of code should look for a book id = 69896.
 * Any changes ara just temporary, they will before-buffer undone anyway:
 *    - if the record is not the one searched the next record should be process
 *    - otherwise break then loop.
 *
 * NOTE:
 * Because of the faulty UNDO, NEXT implementation, the FOR will loop infinitely on the first
 * record of the table book.
 */
FOR EACH book:
   book.isbn = "0012".  /* change something */
   VALIDATE book.       /* force temporary validation, write/flush-to-db */

   IF (book-id NE 69896) THEN
       UNDO, NEXT.     /* process the next record in FOR loop */
   ELSE
       UNDO, LEAVE.    /* leaves the FOR block, the buffer should contain last processed record (69896) */
END.
