/* call counter */
define var i as integer no-undo init 0.
function x return char () :
    i = i + 1.
    return string(i).
end function.


on find   of book display x() "Session trigger FIND for" book.isbn with no-label no-box.
on write  of book old bold display x() "Session trigger WRITE for" book.isbn "old" bold.isbn with no-label no-box.
on create of book display x() "Session trigger CREATE for" book.isbn with no-label no-box.
on delete of book display x() "Session trigger DELETE for" book.isbn with no-label no-box.
on assign of book.isbn old bisbn display x() "Session trigger ASSIGN for" book.isbn "old" bisbn with no-label no-box.

procedure ppp1 :
    display x() "    Inside procedure start" with frame f0 with no-box.
    do transaction:
        display x() "        Inner transaction start" with frame f1 with no-box.
        create book.
        display x() "        Inner transaction end" with frame f2 with no-box.
    end.
    book.publisher = "me".
    display x() "    Inside procedure end" with frame f3 with no-box.
end.

do /*transaction*/:
    display x() "  Outer transaction start" with frame f4 with no-box.
    run ppp1.

    display x() "  Outer transaction continue" with frame f5 with no-box.
    /* assign */
        book.isbn = "111".
        book.book-id = 111.

    create book.
    /* assign */
        book.isbn = "222".
        book.book-id = 222.
    display x() "  Outer transaction end" with frame f6 with no-box.
end.


display x() "Top scope continue " with frame f7 with no-box.

find first book where isbn = "222".
delete book.

find first book where isbn = "111".
delete book.

display x() "Top scope end" with frame f8 with no-box.



/*
   Expected output:

1          Outer transaction start
2            Inside procedure start
3                Inner transaction start
4        Session trigger CREATE for
5                Inner transaction end
6            Inside procedure end
7          Outer transaction continue
8        Session trigger ASSIGN for 111             old
9        Session trigger WRITE for 111             old
10       Session trigger CREATE for
11       Session trigger ASSIGN for 222             old
12         Outer transaction end
13       Top scope continue
14       Session trigger WRITE for 222             old
15       Session trigger FIND for 222
16       Session trigger DELETE for 222
17       Session trigger FIND for 111
18       Session trigger DELETE for 111
19       Top scope end
*/
